#Copyright Jo'zsef Ne'meth 2003, joe.nemeth@cpluscsystems.axelero.net
#Store dll.dll alongside this script
# After loading dll.dll, Dll_Init creates a namespace and
# stores its name in the global variable DLL.

load [file dirname [info script]]/dll.dll

#define void	0x00000000
#define char	0x00000001
#define short	0x00000002
#define int		0x00000004
#define int64	0x00000008
#define float	0x00000010
#define double	0x00000020
#define unsigned	0x00000040
#define numeric	0x00000080
#define string	0x00000100
#define voidret	0x10000000
#define ptr		0x40000000
#define ptrptr	0x80000000
array set type {char 129 short 130 int 132 int64 136 float 144 double 160}
array set type {uchar 193 ushort 194 uint 196 uint64 200 string 256}
array set type {void 0 "" 0 bufret 268435456 * 1073741824 ** 2147483648}

# Create a flag word from a base type and pointer specification
proc ${::DLL}::_getFlag_ {base ptr} {
   upvar #0 type type

   set flag $type($base)
   if {$flag != 129} {
      set flag [expr $flag + $type($ptr)]
   } elseif {$ptr ne ""} {
      set flag [expr $flag + $type($ptr) - 1073741697]
   }
   return [binary format i $flag]
}

# Create a command from a dynamic library function
proc ${::DLL}::cmd {nsp def} {
   upvar #0 type type

   set length [llength $def]
   if {$length != 1 && $length != 3} {
      error "Wrong number of arguments"
   }
   set handle [set ${nsp}::handle]
   set spec [lindex $def 0]
   set defList [regexp -inline -- {^(.*) +([_A-Za-z0-9]+) *\((.*) *$} $spec]
   set name [lindex $defList 2]
   if {$name eq ""} {error "Syntax error"}

   set retspec  [lindex $defList 1]
   if {$retspec eq ""} {error "Return type must be specified"}
   set retval [regexp -inline -- \
                  {^ *(u?char|u?short|u?int|u?int64|void(/[0-9]+)?|float|double) *(\*{0,2}) *} \
                  $retspec]
   if {[lindex $retval 2] ne ""} {
      set params [expr $type(bufret) + $type(*) + [string range [lindex $retval 2] 1 end]]
   } else {
      set params [${::DLL}::_getFlag_ [lindex $retval 1] [lindex $retval 3]]
   }

   set spec [lindex $defList 3]
   set parlist [regexp -inline -all -- \
                  { *(u?char|u?short|u?int|u?int64|void|float|double) *(\*{0,2}) *[,)]} \
                  $spec]

   set cnt 1
   foreach {m t p} $parlist {
      incr cnt
      set params $params[${::DLL}::_getFlag_ $t $p]
   }

   if {$length == 3} {
      if {[lindex $def 1] ne "->"} {
         error "Syntax error"
      }
      set alias [lindex $def 2]
      if {[namespace tail $alias] eq $alias} {
         set alias ${nsp}::$alias
      } elseif {[namespace qualifiers $alias] eq ""} {
         set alias [namespace tail $alias]
      } else {
         error "Invalid alias specification"
      }
   } else {
         set alias ${nsp}::$name
   }
      set address [${::DLL}::create_cmd $alias $handle $name]
   if {!$address} {
      error "Dynamic library function not found"
   }
   set ${::DLL}::entry($alias) \
       [binary format i $handle][binary format i $address][binary format i $cnt]$params[${::DLL}::buffer [expr 8 * $cnt]]
   set ${::DLL}::alias($alias) ${nsp}::$name
}

#Load a dynamic library and register its handle
proc ${::DLL}::load {args} {
   global alias

   set length [llength $args]
   if {$length != 1 && $length != 3} {
      error "Wrong number of arguments"
   }

   set name [file rootname [file tail [lindex $args 0]]]

   if {$length == 3} {
      if {[lindex $args 1] ne "->"} {
         error "Syntax error"
      }
      set alias [lindex $args 2]
   } else {
      set alias $name
   }
   set handle [${::DLL}::load_module [lindex $args 0]]
   if {!$handle} {
      error "Dynamic library not found"
   }

   namespace eval ::$alias {
      variable nsp ${::alias}
      proc cmd {args} {
         variable nsp
         return [${::DLL}::cmd ::$nsp $args]
      }
   }
   set ::${alias}::handle $handle
   set ::${alias}::alias $name
}

