# seek_winamp.tcl
# (c) 2006 Brian Hartvigsen
# This Tcl script is being released as a work in the public domain.  Feel free to
# use, abuse, and modify this script to your heart's content, just do not blame me
# if there are any problems.
#
# This is the original Tcl-bb script that I [Brian Hartvigsen] wrote to demonstrate
# the abilities of Tcl-bb.  I do not guarentee this script to work anymore ;)
# Really it's just here for legacy and to give you something to look at.
# This uses dll.dll [from the library folder.]  Could also be done using twapi.

package require dll

# load up user32.dll
::dll::load user32 -> u

#alias the FindWindowA and SendMessageA Win32 API calls
::u::cmd "int FindWindowA(char *, char *)"
::u::cmd "int SendMessageA(int, int, int, int)"

#@tcl-bb eval seek_winamp %d
proc seek_winamp { pos } {
  global u
  
  # Find the winamp window, should work for everything except 3.0 series
  set winamp [::u::FindWindowA "Winamp v1.x" "null"]
  
  # No Winamp
  if {$winamp == 0} { return -code error "Could not find Winamp Windows" }
  
  # Get current track length from winamp
  set time [::u::SendMessageA $winamp 1024 1 105]
  
  # Possibly no track playing
  if {$time <= 0} { return -code error "Winamp said track length was <= 0"}
  
  # Convert to microseconds..
  set time [expr { $time * 1000 } ]
  
  # New position calculation
  set new_pos [expr { int($pos / 100.0 * $time)}]

  # Tell WinAmp to set new position.
  ::u::SendMessageA $winamp 1024 $new_pos 106
}